﻿using System;
using System.Data;
using System.Drawing;
using System.Text.RegularExpressions;
using System.Windows.Forms;

namespace Flex_Searching_CS
{
    public partial class Form1 : Form
    {
        DataTable dt = new DataTable();
        bool _StartSearch;
        //Brush to color the searched text with Red and Normal text with Black
        SolidBrush brushBlack = new SolidBrush(Color.Black);
        SolidBrush brushRed = new SolidBrush(Color.Red);

        public Form1()
        {
            InitializeComponent();
            dt.Columns.Add("CustomerID",typeof(int));
            dt.Columns.Add("ContactName", typeof(string));
            dt.Columns.Add("Designation", typeof(string));
            dt.Columns.Add("Country", typeof(string));

            //Sample Data
            dt.Rows.Add(1, "Maria Anders", "Sales", "Mexico");
            dt.Rows.Add(2, "Ana Trujillo", "Associate", "Mexico");
            dt.Rows.Add(3, "Antonio Moreno", "Owner", "Ireland");
            dt.Rows.Add(4, "Thomas Hardy", "Representative", "UK");
            dt.Rows.Add(5, "Patricio Simpson", "Marketing", "Germany");
            dt.Rows.Add(6, "Paolo Accorti", "Sales", "Spain");
            dt.Rows.Add(7, "Martine Rancé", "Owner", "Mexico");
            dt.Rows.Add(8, "Elizabeth Brown", "Marketing Manager", "UK");
            dt.Rows.Add(9, "Jaime Yorres", "Order Administrator", "Austria");
            dt.Rows.Add(10, "Yvonne Moncada", "Marketing Manager", "Mexico");
            dt.Rows.Add(11, "Helen Bennett", "Owner/Marketing", "Ireland");
            dt.Rows.Add(12, "Sergio Gutiérrezy", "Order Administrator", "Brazil");
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            c1FlexGrid1.DataSource = dt;
            c1FlexGrid1.AutoSizeCols();
            //To enable control to fire OwnerDrawCell Event
            c1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw;
            c1FlexGrid1.OwnerDrawCell += c1FlexGrid1_OwnerDrawCell;
        }

        private void tbSearchBox_TextChanged(object sender, EventArgs e)
        {
            //If TextBox contains No Text
            if (tbSearchBox.Text == string.Empty)
            {
                _StartSearch = false;

                C1.Win.C1FlexGrid.CellRange rg = new C1.Win.C1FlexGrid.CellRange();
                rg.c1 = 1;
                rg.c2 = c1FlexGrid1.Cols.Count - 1;
                rg.r1 = 1;
                rg.r2 = c1FlexGrid1.Rows.Count - 1;
                //Select all cells to redraw their content with default color
                c1FlexGrid1.Select(rg);
                C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
                //To avoid selection of all cells, select nothing
                c1FlexGrid1.Select(rg1);
            }

            //If TextBox contains some text to be searched
            else
            {
                _StartSearch = true;

                C1.Win.C1FlexGrid.CellRange rg = new C1.Win.C1FlexGrid.CellRange();
                c1FlexGrid1.Select(rg);
                rg.c1 = 1;
                rg.c2 = c1FlexGrid1.Cols.Count - 1;
                rg.r1 = 1;
                rg.r2 = c1FlexGrid1.Rows.Count - 1;
                //Select all cells to search the Grid and redraw search results with Red ForeColor
                c1FlexGrid1.Select(rg);
                C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
                c1FlexGrid1.Select(rg1);
            }
        }
        void c1FlexGrid1_OwnerDrawCell(object sender, C1.Win.C1FlexGrid.OwnerDrawCellEventArgs e)
        {
            //To avoid drawing of Fixed Row
            if (e.Row != 0)
            {
                //Test whether OwnerDrawCell is used for searching or default drawing of cells
                if (_StartSearch)
                {
                    int _OccuranceOfSearchedText = 0;
                    int occured = 0;
                    Single x = 0;
                    bool found = false;
                    string CellContent = e.Text;

                    if (CellContent.Contains(tbSearchBox.Text))
                    {
                        //To check no of times searched text appears in current cell
                        _OccuranceOfSearchedText = Regex.Matches(CellContent, tbSearchBox.Text).Count;

                        if (_OccuranceOfSearchedText == 1)
                        {
                            for (int i = 0; i < CellContent.Length; )
                            {
                                if (CellContent[i] == tbSearchBox.Text[0])
                                {
                                    found = true;
                                    //To check whether searched text is found in cell or not
                                    for (int j = 1, k = i+1; j < tbSearchBox.Text.Length; j++, k++)
                                    {
                                        if (k == CellContent.Length)
                                        {
                                            found = false;
                                        }
                                        else if (CellContent[k] != tbSearchBox.Text[j])
                                        {
                                             found = false;
                                        }
                                    }

                                    if (found)
                                    {
                                        for (int l = i; l < (i + tbSearchBox.Text.Length); l++)
                                        {
                                            //Color the Text of Search Result with Red
                                            e.Graphics.DrawString(CellContent[l].ToString(), c1FlexGrid1.Font, brushRed, e.Bounds.X + x, e.Bounds.Y);
                                            //Next character needs to be shifted right;
                                            //depending on the space occupied by the previous character as per its FontSize/FontStyle
                                            x += (e.Graphics.MeasureString(CellContent[l].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                        }
                                        for (int l = i + tbSearchBox.Text.Length; l < CellContent.Length; l++)
                                        {
                                            e.Graphics.DrawString(CellContent[l].ToString(), c1FlexGrid1.Font, brushBlack, e.Bounds.X + x, e.Bounds.Y);
                                            x += (e.Graphics.MeasureString(CellContent[l].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                        }
                                        break;
                                    }
                                    else
                                    {
                                        e.Graphics.DrawString(CellContent[i].ToString(), c1FlexGrid1.Font, brushBlack, e.Bounds.X + x, e.Bounds.Y);
                                        x += (e.Graphics.MeasureString(CellContent[i].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                        ++i;
                                    }
                                }
                                else
                                {
                                    e.Graphics.DrawString(CellContent[i].ToString(), c1FlexGrid1.Font, brushBlack, e.Bounds.X + x, e.Bounds.Y);
                                    x += (e.Graphics.MeasureString(CellContent[i].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                    ++i;
                                }
                            }
                        }

                        else
                        {
                            for (int i = 0; i < e.Text.Length; )
                            {
                                if (CellContent[i] == tbSearchBox.Text[0])
                                {
                                    found = true;
                                    //To check whether searched text is found in cell or not
                                    for (int j = 1, k = i + 1; j < tbSearchBox.Text.Length; j++, k++)
                                    {
                                        if (k == CellContent.Length)
                                        {
                                            found = false;
                                        }
                                        else if (CellContent[k] != tbSearchBox.Text[j])
                                        {
                                            found = false;
                                        }
                                    }
                                    if (found)
                                    {
                                        for (int l = i; l < (i + tbSearchBox.Text.Length); l++)
                                        {
                                            e.Graphics.DrawString(CellContent[l].ToString(), c1FlexGrid1.Font, brushRed, e.Bounds.X + x, e.Bounds.Y);
                                            x += (e.Graphics.MeasureString(CellContent[l].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                        }
                                        
                                        ++occured;
                                        if (occured == _OccuranceOfSearchedText)
                                        {
                                            for (int l = i + tbSearchBox.Text.Length; l < CellContent.Length; l++)
                                            {
                                                e.Graphics.DrawString(CellContent[l].ToString(), c1FlexGrid1.Font, brushBlack, e.Bounds.X + x, e.Bounds.Y);
                                                x += (e.Graphics.MeasureString(CellContent[l].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                            }
                                            break;
                                        }
                                        i = i + tbSearchBox.Text.Length;
                                    }
                                    else
                                    {
                                        e.Graphics.DrawString(CellContent[i].ToString(), c1FlexGrid1.Font, brushBlack, e.Bounds.X + x, e.Bounds.Y);
                                        x += (e.Graphics.MeasureString(CellContent[i].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                        ++i;
                                    }
                                }
                                else
                                {
                                    e.Graphics.DrawString(CellContent[i].ToString(), c1FlexGrid1.Font, brushBlack, e.Bounds.X + x, e.Bounds.Y);
                                    x += (e.Graphics.MeasureString(CellContent[i].ToString(), this.c1FlexGrid1.Font)).Width - 3;
                                    ++i;
                                }
                            }
                        }
                        e.Handled = true;
                    }
                }

                //Whether Search completed throughout all cells of grid
                if (e.Row == c1FlexGrid1.Rows.Count && e.Col == c1FlexGrid1.Cols.Count)
                {
                    _StartSearch = false;
                }
            }
        }

        private void _btnClear_Click(object sender, EventArgs e)
        {
            //Clear the TextBox
            tbSearchBox.Text = string.Empty;
            _StartSearch = false;

            C1.Win.C1FlexGrid.CellRange rg = new C1.Win.C1FlexGrid.CellRange();
            rg.c1 = 1;
            rg.c2 = c1FlexGrid1.Cols.Count - 1;
            rg.r1 = 1;
            rg.r2 = c1FlexGrid1.Rows.Count - 1;
            //Select all cells to redraw their content with default color
            c1FlexGrid1.Select(rg);
            C1.Win.C1FlexGrid.CellRange rg1 = new C1.Win.C1FlexGrid.CellRange();
            //Select nothing in Grid
            c1FlexGrid1.Select(rg1);
        }
    }
}
